/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: websocket.c 148 2016-01-08 05:35:52Z coas-nagasima $
 */

#include <string.h>
#include "websocket.h"
#include "uip.h"
#include "kernel.h"
#include "kernel_cfg.h"

static ECN_FBS_ID cur_out_msg;

void websocket_init(struct websocket *ws, ID wbsid)
{
	memset(ws, 0, sizeof(*ws));
	ws->wbsid = wbsid;
}

void websocket_destroy(struct websocket *ws)
{
	if ((cur_out_msg.ptr != NULL) && (((ID *)cur_out_msg.ptr->_gap)[0] == ws->wbsid))
	{
		_ecn_fbs_del(cur_out_msg);
		memset(&cur_out_msg, 0, sizeof(cur_out_msg));
	}

	if (ws->cur_in_msg.ptr != NULL) {
		_ecn_fbs_del(ws->cur_in_msg);
		memset(&ws->cur_in_msg, 0, sizeof(ws->cur_in_msg));
	}

	ws->wbsid = 0;
}

int websocket_input(struct websocket *ws, const void *data, int len)
{
	ws_state_t *s = &ws->rstate;
	const u8_t *pos = (const u8_t *)data, *end = &((const u8_t *)data)[len];

	for(; pos < end; pos++){
		switch (s->state)
		{
		// FIN RSV1-3 OPECODE
		case 0:
			s->fin = (*pos & 0x80) != 0;
			s->opecode = (enum opecode_t)(*pos & 0x0F);
			s->state = 1;
			break;
		// MASK Payload len
		case 1:
			// MASK=0NG
			if((*pos & 0x80) == 0)
				return -1/*MASK_ERROR*/;

			switch(*pos & 0x7F){
			case 127:
				s->payload_len = 0;
				s->state = 2/*7+64bit*/;
				break;
			case 126:
				s->payload_len = 0;
				s->state = 8/*7+16bit*/;
				break;
			default:
				s->payload_len = *pos & 0x7F;
				s->state = 10/*7bit*/;
				break;
			}
			break;
		// 64bit Extended payload length
		case 2: case 3: case 4: case 5: case 6: case 7:
		// 16bit Extended payload length
		case 8: case 9:
			s->payload_len = (s->payload_len << 8) + *pos;
			s->state++;
			break;
		// Masking-key
		case 10: case 11: case 12:
			s->masking_key[s->state - 10] = *pos;
			s->state++;
			break;
		case 13:
			s->masking_key[3] = *pos;

			s->data_pos = 0;
			if (s->payload_len <= 0) {
				s->state = 0;
			}
			else {
				_ecn_fbs_cre(1, &ws->cur_in_msg);
				s->state++;
			}
			break;
		// Payload buffer
		default:
			if(ws->cur_in_msg.ptr != NULL)
				_ecn_fbs_poke(ws->cur_in_msg, s->data_pos, *pos ^ s->masking_key[s->data_pos % 4]);

			s->data_pos++;
			if (s->data_pos >= s->payload_len) {
				ER ret;
				s->state = 0;

				if (ws->cur_in_msg.ptr != NULL) {
					((ID *)ws->cur_in_msg.ptr->_gap)[0] = ws->wbsid;
					ret = psnd_dtq(ecn_api_mailboxid, (intptr_t)ws->cur_in_msg.ptr);
					if (ret != E_OK) {
						syslog(LOG_WARNING, "websocket_input() : psnd_dtq(%d) result = %d", ecn_api_mailboxid, ret);
						_ecn_fbs_del(ws->cur_in_msg);
					}
				}
				memset(&ws->cur_in_msg, 0, sizeof(ws->cur_in_msg));
			}
			break;
		}
	}

	return 0;
}

bool_t websocket_newdata(struct websocket *ws)
{
	ws_state_t *s = &ws->wstate;
	struct websocket *mws;
	ER ret;
	ECN_FBS_ID data;
	ID wbsid;

	if(s->state != 0)
		return true;

	if (cur_out_msg.ptr != NULL)
		return (((ID *)cur_out_msg.ptr->_gap)[0] == ws->wbsid);

	for (;;) {
		ret = prcv_dtq(WEBSOCKET_MBXID, (intptr_t *)&data.ptr);
		if (ret == E_TMOUT)
			return false;

		if (ret != E_OK) {
			TOPPERS_assert_abort();
			return false;
		}

		wbsid = ((ID *)data.ptr->_gap)[0];
		mws = websocket_getws(wbsid);
		if ((mws != NULL) && (mws->wbsid != 0))
			break;

		_ecn_fbs_del(cur_out_msg);
	}

	cur_out_msg.ptr = data.ptr;

	return (wbsid == ws->wbsid);
}

int websocket_output(struct websocket *ws, void *data, int len)
{
	ws_state_t *s = &ws->wstate;
	u8_t *pos = (u8_t *)data, *end = &((u8_t *)data)[len];

	for(; pos < end; pos++){
		switch (s->state)
		{
		// FIN RSV1-3 OPECODE
		case 0:
			if ((cur_out_msg.ptr == NULL) || (((ID *)cur_out_msg.ptr->_gap)[0] != ws->wbsid))
				return (intptr_t)pos - (intptr_t)data;

			s->payload_len = _ecn_fbs_get_datalen(cur_out_msg);
			if(s->payload_len == 0){
				goto next;
			}

			s->fin = 1;
			s->opecode = text_frame;
			s->masked = 0;//
			s->masking_key[0] = 0;//0x01;
			s->masking_key[1] = 0;//0x23;
			s->masking_key[2] = 0;//0x45;
			s->masking_key[3] = 0;//0x67;

			*pos = ((s->fin != 0) ? 0x80 : 0)
				| ((char)s->opecode & 0x0F);
			s->state = 1;
			break;
		// MASK Payload len
		case 1:
			if(s->payload_len < 126){
				*pos = ((s->masked != 0) ? 0x80 : 0) | s->payload_len;
				if (s->masked != 0) {
					s->state = 10/*7bit*/;
				}
				else{
					goto payload_check;
				}
			}
			else if(s->payload_len < 0x10000){
				*pos = ((s->masked != 0) ? 0x80 : 0) | 126;
				s->state = 8/*7+16bit*/;
			}
			else{
				*pos = ((s->masked != 0) ? 0x80 : 0) | 127;
				s->state = 2/*7+64bit*/;
			}
			break;
		// 64bit Extended payload length
		case 2: case 3: case 4: case 5: case 6: case 7:
		// 16bit Extended payload length
		case 8: case 9:
			*pos = (s->payload_len >> (8 * (9 - s->state)));
			s->state++;
			if((s->state == 10) && (s->masked == 0)){
				goto payload_check;
			}
			break;
		// Masking-key
		case 10: case 11: case 12:
			*pos = s->masking_key[s->state - 10];
			s->state++;
			break;
		case 13:
			*pos = s->masking_key[3];
			s->state++;
		payload_check:
			s->data_pos = 0;
			if (s->data_pos < s->payload_len)
				s->state = 14;
			else
				goto next;
			break;
		// Payload buffer
		default:
			*pos = _ecn_fbs_peek(cur_out_msg, s->data_pos) ^ s->masking_key[s->data_pos % 4];

			s->data_pos++;
			if(s->data_pos >= s->payload_len){
				goto next;
			}
			break;
		next:
			_ecn_fbs_del(cur_out_msg);
			memset(&cur_out_msg, 0, sizeof(cur_out_msg));
			s->state = 0;
			websocket_newdata(ws);
			break;
		}
	}

	return (intptr_t)pos - (intptr_t)data;
}
